<?php

namespace App\Repositories\Botanic;

use Illuminate\Support\Str;

use Maatwebsite\Excel\Facades\Excel;

use App\Repositories\Core\Tag;
use App\Models\Botanic\Variety;
use App\Exports\Botanic\VarietiesExport;
use App\Traits\Repository\Imageable;

class Varieties
{
    use Imageable;

    public static function getOptions()
    {
        return Variety::orderBy('name')->get()->pluck('name', 'id')->toArray();
    }

    public static function getOptionsWithSpecie()
    {
        $varieties = Variety::with('specie')->get();
        $data = [];
        foreach ($varieties as $variety) {
            $data[$variety->id] = (isset($variety->specie->name) ? $variety->specie->name . ' ' : '') . $variety->name;
        }
        asort($data, SORT_NATURAL | SORT_FLAG_CASE);
        return $data;
    }

    public static function getAll()
    {
        return Variety::orderBy('name', 'asc')->get();
    }

    public static function getDescription($id)
    {
        return self::get($id)->description;
    }

    public static function getTags($id)
    {
        return self::get($id)->tags;
    }

    public static function get($id)
    {
        return Variety::with('tags.tag_group')->findOrFail($id);
    }

    public static function getFull($id)
    {
        $variety = self::get($id);
        $data = $variety->toArray();
        $data['tags'] = self::getTagsByVariety($variety);
        return $data;
    }

    public static function getTagsByVariety($variety)
    {
        return Tag::getTagsByModel($variety);
    }

    public static function storeFull($data)
    {
        $images = isset($data['images']) ? $data['images'] : false;
        $tags = isset($data['tags']) ? $data['tags'] : false;
        unset($data['images']);
        unset($data['tags']);
        $variety = self::store($data);
        self::storeImages($variety, $images);
        self::storeTags($variety, $tags);
        return $variety;
    }

    public static function store($data)
    {
        return ($data['id'] ?? false) ? self::update($data) : self::create($data);
    }

    public static function create($data)
    {
        return Variety::create($data);
    }

    public static function update($data, $id = false)
    {
        $id = $id ? $id : $data['id'];
        $variety = self::get($id);
        $ret = $variety->update($data);
        return $variety;
    }

    public static function destroy($id)
    {
        return Variety::destroy($id);
    }

    public static function storeTags($variety, $tags)
    {
        return Tag::storeTags($variety, $tags);
    }

    public static function exportExcel()
    {
        return Excel::download(new VarietiesExport, 'varieties.xlsx');
    }
}
